Subject: Re: Question with commit 299b0767(ipv6: Fix IPsec slowpath fragmentation problem)

From: Steffen Klassert <[email-masked]>
Date: Tue, 14 Feb 2012 12:04:14 +0100

On Mon, Feb 13, 2012 at 04:10:39PM +0800, Li Wei wrote:
> Hi, Steffen!
> 
> I found some problem while doing networking tests with IPSec that
> the first fragment doesn't use the max MTU to fill payload, but with
> 20 bytes smaller. When I reverted your commit 299b0767(ipv6: Fix 
> IPsec slowpath fragmentation problem), things goes well.
> 
> Would you so kindly to point me out what the commit did, because I
> think the original implementation had taken IPSec header and tailer
> into account.
> 

Without this patch we used always the slow path in ip6_fragment()
due to a miscalculation of the packet lenght in ip6_append_data().

This patch just makes use of the reduced IPsec mtu, and adapts
the IPsec header handling to have enought headroom on the skb.